﻿// Windows 10のバージョン番号をRtlGetVersionのビルド番号から取得する。

#include <windows.h>
#include <tchar.h>

//	DLL内の関数へのポインタ型を定義
typedef void (WINAPI *RtlGetVersion_FUNC)(OSVERSIONINFOEXW*);

int win10ver2(void){
	int ver = 0;
	HMODULE hMod;
	OSVERSIONINFOEXW osw;
	hMod = LoadLibrary(TEXT("ntdll.dll"));
	RtlGetVersion_FUNC func;
	if (hMod){
		func = (RtlGetVersion_FUNC)GetProcAddress(hMod, "RtlGetVersion");
		if (func == 0){
			FreeLibrary(hMod);
			return FALSE;
		}
		ZeroMemory(&osw, sizeof(osw));
		osw.dwOSVersionInfoSize = sizeof(osw);
		func(&osw);
		FreeLibrary(hMod);
		if (osw.dwMajorVersion == 10){
			switch (osw.dwBuildNumber){
			case 10240: ver = 1507; break;
			case 10586: ver = 1511; break;
			case 14393: ver = 1607; break;
			case 15063: ver = 1703; break;
			case 16299: ver = 1709; break;
			case 17134: ver = 1803; break;
			case 17763: ver = 1809; break;
			default: ver = 1809; break;
			}
			return ver;
		}
	}
	return -1;
}

int WIN10VER;

int WINAPI _tWinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst, TCHAR* lpsCmdLine, int nCmdShow){
	TCHAR buf[16];
	WIN10VER=win10ver2();
	if (0<WIN10VER){
		_stprintf_s(buf, sizeof(buf) / sizeof(buf[0]), _TEXT("Version %d"), WIN10VER);
		MessageBox(0,buf,_TEXT("Windows 10") ,MB_OK);
	}
	else{
		MessageBox(0,0,_TEXT("バージョンが正常に取得できませんでした。"),MB_OK);
	}
	return 0;
}
